package org.adamgulczynski;

import org.json.JSONObject;

public class WeatherParser {

    public static WeatherData parseWeatherToWeatherData(String response) {

        JSONObject jsonObject = new JSONObject(response);

        String city = jsonObject.getString("name");
        double temperature = jsonObject.getJSONObject("main").getDouble("temp");
        int humidity = jsonObject.getJSONObject("main").getInt("humidity");
        double windSpeed = jsonObject.getJSONObject("wind").getDouble("speed");
        int clouds = jsonObject.getJSONObject("clouds").getInt("all");
        int pressure = jsonObject.getJSONObject("main").getInt("pressure");

        return new WeatherData(city, temperature, humidity, windSpeed, clouds, pressure);
    }
}
