package org.example;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;

public class Main {

    public static void main(String[] args) {

        // configure the db connection
        Configuration configuration = new Configuration();
        configuration.configure("hibernate.cfg.xml");
        SessionFactory sessionFactory = configuration.buildSessionFactory();

        try (Session session = sessionFactory.openSession()) {

            MyQuery myQuery = new MyQuery(session);

            // here, replace "test" with the title of the book you want to query
            String title1 = "1984";
            myQuery.getBookByExactTitle(title1);

            // here, replace "test" with the title of the book you want to query
            String title2 = "Pride and Prejudice";
            myQuery.getBookDetailsWithAuthorByTitle(title2);

            // here, set the book id you want to query
            Long id = 1L;
            // here, set page number and page size
            int pageNumber = 1;
            int pageSize = 10;
            myQuery.getBookReviewsByBookId(id, pageNumber, pageSize);

            Transaction tx = null;
            try {
                tx = session.beginTransaction();
                // create a book
                String bookTitle = "test book title";
                Book book = MyQuery.createBook(bookTitle);
                session.save(book);

                // create an Author
                String authorName = "Adam Gulczynski";
                Author author = MyQuery.createAuthor(authorName);
                session.save(author);
//
                // create book details

                String isbn = "1234-0000332";
                int pageCount = 123;
                BookDetails bookDetails = MyQuery.createBookDetails(isbn, pageCount, book, author);
                session.save(bookDetails);

                // create a book review
                int rating = 5;
                String reviewText = "Great book!";
                String reviewerName = "Adam";
                Review review = MyQuery.createReview(rating, reviewText, book, reviewerName);
                session.save(review);

                tx.commit();
            } catch (Exception e) {
                if (tx != null) {
                    tx.rollback();
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            sessionFactory.close();
        }
    }
}